config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root to: 'staff/dashboard#show' 
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  namespace :staff do
    resource :dashboard, controller: :dashboard do
      collection do
        get :tats
        get :reports
        get :staffs_report
        get :executives_report
      end
    end
      resources :cases do
      collection do
        get :upload_file
        post :upload_mapping
        post :upload
        get :search
        put :bulk_assignment
        get :out_of_tats
        get :today_tats
        get :tomorrow_tats
      end
      member do
        get  :mark_approved
        post :upload_attachment
        post :upload_verification_detail
        get :crop_attachment
      end

      resources :attachments
    end
    resources :clients
    resources :users
  end

  namespace :executive do
    resources :cases do
      collection do
        get :verification_completed
        get :print_all
      end
      member do
        post :upload_attachment
        get :template
        post :upload_verification_detail
        get  :mark_verification_completed
        get :redo
        post :set_untraceable
      end
    end
  end
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  has_many :cases
  has_many :attachments
  has_many :case_investigations

  validates :name, :email, :role,  presence: true

  has_attached_file :photo,
  storage: :cloudinary,
  path: ':id/:style/:filename'
  #validates_attachment_file_name :file, :matches => [/png\Z/, /jpe?g\Z/, /gif\Z/, /pdf\Z/]
  do_not_validate_attachment_file_type :photo

  ROLES = ['admin', 'staff', 'executive']
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/staff/attachments_controller.rb
class Staff::AttachmentsController < ApplicationController
  before_action :find_case
  before_action :find_attachment

  def show
  end

  private
    def find_case
      @case = Case.find params[:case_id]
    end

    def find_attachment
      @attachment = @case.attachments.find params[:id]
    end
end

app/controllers/staff/cases_controller.rb
class Staff::CasesController < ApplicationController
  require 'csv'

  before_action :find_case, only: %w(show crop_attachment)

  include UploadMappings

  def index
    @users = User.where(role: 'executive')
    @clients =Client.all
    @cases = Case.where.not(status: 'approved').order(created_at: :desc)
  end

  def tats
  end

  def out_of_tats
    @users = User.where(role: 'executive')
    @cases = Client.total_out_of_tats
    render action: :index
  end

  def today_tats 
    @users = User.where(role: 'executive')
    @cases = Client.total_tats_today
    render action: :index
  end

  def tomorrow_tats
    @users = User.where(role: 'executive')
    @cases = Client.total_tats_tomorrow
    render action: :index
  end

  def upload_file
    @clients = Client.all
  end

  def upload_mapping
    @clients = Client.all
    if params[:csv].present?
      @csv = CSV.parse(params[:csv].read, headers: true)
      @client = Client.find(params[:client_id])
      fn = "upload_mapping_#{@client.client_format}_#{params[:case_type]}"
      if respond_to?(fn)
        if (@cases = send(fn))
          session[:cases] = @cases
        else
          render action: :upload_file
        end
      else
        flash[:notice] = "Selected type is not supported"
        render action: :upload_file
      end
    else
      flash[:notice] = "Please upload the file"
      render action: :upload_file
    end
  end

  def upload
    session[:cases].each do |c|
      #ca = Case.find_or_initialize_by(client_ref_no: c['client_ref_no'])
      #ca.attributes = c
      #ca.save!
      c.stringify_keys!
      @cases = Case.find_by(client_ref_no: c['client_ref_no'])
      if @cases.present?
        @cases.update_attributes(c)
      else
        Case.open.create!(c)
      end
    end
    redirect_to staff_cases_path
  end

  def show 
    @case = Case.find(params[:id])
    @case_investigation = CaseInvestigation.find_by(case_id: @case.id, user_id:  @case.user_id)
    unless @case_investigation.present?
      @case_investigation = CaseInvestigation.new
    end
  end


  def upload_attachment
    attachment_params.each do |attach_param|
      if attach_param[:document].present?
        attachment = Attachment.new(attach_param)
        attachment.case_id = @case.id
        attachment.user_id = current_user.id
        attachment.save!
      end
    end
  end

  def upload_verification_detail
    @case = Case.find(params[:id])
    @verified_case = CaseInvestigation.find_by(case_id: @case.id, user_id: @case.user_id)

    if @verified_case.present?
      @verified_case = @verified_case.update_attributes(case_investigation_params)
    else
      @verified_case = CaseInvestigation.new(case_investigation_params)
      @verified_case.case_id = @case.id
      @verified_case.user_id = current_user.id
      @verified_case.save!
    end
    redirect_to staff_case_path(@case)
  end


  def mark_approved
    @case = Case.find(params[:id])
    if @case.status == "verification_completed"
      @case.staff_id = current_user.id
      @case.status = "approved"
      @case.save!
    end
      redirect_to staff_cases_path
  end

  def search
    params[:search] ||= {}
    @users = User.where(role: 'executive')
    @cases = Case.where("1=1")
    @cases = @cases.where(status: params[:search][:status]) if params[:search][:status].present?
    
    if params[:search][:query].present?
      query = '%' + params[:search][:query] + '%'
      @cases = @cases.where("address ILIKE ?", query)
    end

    if params[:search][:client_id].present?
      @cases = @cases.where(client_id: params[:search][:client_id])
    end

    if params[:search][:user_id].present?
      @cases = @cases.where(user_id: params[:search][:user_id])
    end

    if params[:search][:case_type].present?
      @cases = @cases.where(case_type: params[:search][:case_type]) 
    end

    respond_to do |format|
      format.html { render action: :index }
      format.csv { send_data @cases.to_csv, filename: "cases-#{Date.today}.csv" }
    end
  end




  def bulk_assignment
    if params[:case_ids].present?
      params[:case_ids].each do |case_id|
        c = Case.find(case_id)
        c.update_attributes user_id: params[:user_id], status: "in_progress"
      end
    else
      flash[:notice] = "select cases"
    end
    redirect_to staff_cases_path
  end

  def crop_attachment
    @attachment = @case.attachments.find(params[:attachment_id])
  end

  def attachment_params
    params.require(:attachments).map{|p| p.permit(:document)}
  end

  def case_investigation_params
    params.require(:case_investigation).permit(:visited_at, :address_changed, :land_mark, :locality, :accommodation_type, :duration_of_stay, :building_color, :building_type, :id_number, :respondent_name, :respondent_relationship, :respondent_contact_no, :police_station_name, :remarks, extras: {})
  end

  def find_case
    @case = Case.find(params[:id])
  end
end

app/controllers/staff/clients_controller.rb
class Staff::ClientsController < ApplicationController

  def new
    @client = Client.new
  end

  def create
    @client = Client.new(client_params)
    if @client.save
      redirect_to staff_clients_path
    else
      render action: :new
    end
  end

  def index
    @clients = Client.all.order(created_at: :asc)
  end

  def update
    @client = Client.find(params[:id])
    if @client.update_attributes(client_params)
        flash[:success]="Successfully updated"
        redirect_to staff_clients_path()
      else
        render 'edit'
    end
  end 

  def edit
    @client = Client.find(params[:id])
  end

  private

    def client_params
      params.require(:client).permit(:name,:email,:client_format)
    end
end

app/controllers/staff/dashboard_controller.rb
class Staff::DashboardController < ApplicationController

  def show
    @cases = Case.all
    @executives = User.where(role: 'executive')
    @staffs = User.where(role: 'staff')
  end



  def reports
  end

  def staffs_report
    @user = User.find(params[:staff_id])
    @cases = Case.where(staff_id: @user.id, status: ["approved"])
    render action: :reports
  end

  def executives_report
    @user = User.find(params[:executive_id])
    @cases = Case.where(user_id: @user.id, status: ["approved", "verification_completed"])
    render action: :reports
  end

end

app/controllers/staff/users_controller.rb
class Staff::UsersController < ApplicationController

  def new
    @user = User.new()
  end

  def create
    @user = User.new(user_params)
    respond_to do |format|
      if @user.save
        redirect_to staff_users_path
        else
        render action: :new
      end
    end 
  end

  def index
    @users = User.all.order(created_at: :asc)
  end


  def update
    @user = User.find(params[:id])
    @user.update_attributes(user_params)
    render 'edit'
  end 


  def edit
    @user = User.find(params[:id])
  end

  private

    def user_params
      params.require(:user).permit(:name, :l_name, :dob, :id_proof, :photo,  :email, :password, :phone, :address, :role, :password_confirmation)
    end

end

app/helpers/staff/attachments_helper.rb
module Staff::AttachmentsHelper
end

app/helpers/staff/cases_helper.rb
module Staff::CasesHelper
end

app/helpers/staff/clients_helper.rb
module Staff::ClientsHelper
end

app/helpers/staff/dashboard_helper.rb
module Staff::DashboardHelper
end

app/helpers/staff/users_helper.rb
module Staff::UsersHelper
end

app/views/staff/users/edit.html.erb
<div class = "row" >
  <div class="col-lg-8 offset-lg-2 ">
    <div class="card card-small mb-4">
      <div class="card-header border-bottom">
        <h6 class="m-0">User Details</h6>
      </div>
      <ul class="list-group list-group-flush">
        <li class="list-group-item p-3">
          <div class="row">
            <div class="col">
              <%= form_for @user, url: staff_user_path(@user) do |f| %>

                <div class="form-row">
                  <div class="form-group  col-md-6">
                    <%= f.label :"First Name" %>
                    <%= f.text_field :name, class: "form-control" %>
                  </div>
                  <div class="form-group  col-md-6">
                    <%= f.label :"Last Name" %>
                    <%= f.text_field :l_name, class: "form-control" %>
                  </div>
                </div>
                
                <div class="form-row">
                  <div class="form-group col-md-6">
                    <%= f.label :"DOB" %>
                    <%= f.date_field :dob, class: "form-control" %>
                  </div>
                  <div class="form-group col-md-6">
                    <%= f.label :"Phone No" %>
                    <%= f.text_field :phone, class: "form-control" %>
                  </div>
                </div>

                <div class="form-group">
                  <%= f.label :"Address" %>
                  <%= f.text_field :address, class: "form-control" %>
                </div>


                <div class="form-row">
                  <div class="form-group col-md-6">
                    <%= f.label :"Email" %>
                    <%= f.email_field :email, class: "form-control" %>
                  </div>
                  <div class="form-group col-md-6">
                    <%= f.label :"Photo" %>
                    <%= f.file_field :photo, class: "form-control" %>
                  </div>
                </div>

                <!--<div class="form-row">
                  <div class="form-group col-md-6">
                    <%#= f.label :"Password" %>
                    <%#= f.password_field :password, class: "form-control" %>
                  </div>

                  <div class="form-group col-md-6">
                    <%#= f.label :"Password Confirmation" %>
                    <%#= f.password_field :password_confirmation, class: "form-control" %>
                  </div>
                </div>-->

                              <div class="form-row">
                  <div class="form-group col-md-6">
                      <%= f.label :"Role" %>
                      <%= f.select :role, options_for_select(User::ROLES, selected: f.object.role), {}, class: "form-control", style: "text-color: black;" %>
                  </div>
                </div>
           
                <button type="submit" class="btn btn-accent">Update</button>
              <% end %>
            </div>
          </div>
        </li>
      </ul>
    </div>
  </div>
</div>

app/views/staff/users/index.html.erb
<div class="row">
  <div class="col">
    <div class="card card-small mb-4">
      <div class="card-header border-bottom">
         <%= link_to "Add New User", new_staff_user_path, class: "mb-2 btn btn-outline-primary mr-2", style: "float: right;"%>
        <h6 class="m-0">Users</h6>
      </div>
      <% if @users.present? %>
      <div class="card-body p-0 pb-3 text-center">
        <table class="table mb-0">
          <thead class="bg-light">
            <tr>
              <th class="border-0">#</th>
              <th class="border-0">Name</th>
              <th class="border-0">Email</th>
              <th class="border-0">Phone</th>
              <th class="border-0">Role</th>
            </tr>
          </thead>
          <tbody>
            <% @users.each do |user| %>
              <tr>
                <td><%= user.id %></td>
                <td><%= link_to user.name, edit_staff_user_path(user) %></td>
                <td><%= user.email %></td>
                <td><%= user.phone %> </td>
                <td><%= user.role %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      </div>
      <% else %>
        <strong> You don't have Users </strong>
      <% end %>
    </div>
  </div>
</div>

app/views/staff/users/new.html.erb
<div class = "row" >
  <div class="col-lg-8 offset-lg-2 ">
    <div class="card card-small mb-4">
      <div class="card-header border-bottom">
        <h6 class="m-0">New User</h6>
      </div>
      <ul class="list-group list-group-flush">
        <li class="list-group-item p-3">
          <div class="row">
            <div class="col">
              <%= form_for @user, url: staff_users_path do |f| %>
                <%= f.error_messages %>
                <div class="form-row">
                  <div class="form-group col-md-6">
                    <%= f.label :"First Name" %>
                    <%= f.text_field :name, class: "form-control" %>
                  </div>
                  <div class="form-group col-md-6">
                      <%= f.label :"Last Name" %>
                      <%= f.text_field :l_name, class: "form-control" %>
                  </div>
                </div>

                <div class="form-row">
                  <div class="form-group col-md-6">
                    <%= f.label :"DOB" %>
                    <%= f.date_field :dob, class: "form-control" %>
                  </div>
                  <div class="form-group col-md-6">
                    <%= f.label :"Phone No" %>
                    <%= f.text_field :phone, class: "form-control" %>
                  </div>
                </div>

                <div class="form-group">
                  <%= f.label :"Address" %>
                  <%= f.text_field :address, class: "form-control" %>
                </div>


                <div class="form-row">
                  <div class="form-group col-md-6">
                    <%= f.label :"Email" %>
                    <%= f.email_field :email, class: "form-control" %>
                  </div>
                  <div class="form-group col-md-6">
                    <%= f.label :"Photo" %>
                    <%= f.file_field :photo, class: "form-control" %>
                  </div>
                </div>

                <div class="form-row">
                  <div class="form-group col-md-6">
                    <%= f.label :"Password" %>
                    <%= f.password_field :password, class: "form-control" %>
                  </div>

                  <div class="form-group col-md-6">
                    <%= f.label :"Password Confirmation" %>
                    <%= f.password_field :password_confirmation, class: "form-control" %>
                  </div>
                </div>

                              <div class="form-row">
                  <div class="form-group col-md-6">
                      <%= f.label :"Role" %>
                      <%= f.select :role, options_for_select(User::ROLES, selected: f.object.role), {}, class: "form-control", style: "text-color: black;" %>
                  </div>
                </div>
           
                <button type="submit" class="btn btn-accent">Submit</button>
              <% end %>
            </div>
          </div>
        </li>
      </ul>
    </div>
  </div>
</div>